# HG changeset patch
# User Philippe Pepiot <phil@philpep.org>
# Date 1255012468 -7200
# Node ID 52f84e8dbd8d07bb7f55571a643859d18854833b
# Parent  e41d5258ae7e56ee97797ca091a4bcfea18060e4
Use asprintf instead of sprintf

diff -r e41d5258ae7e -r 52f84e8dbd8d hwstat.c
--- a/hwstat.c	Sat Oct 03 19:30:07 2009 +0200
+++ b/hwstat.c	Thu Oct 08 16:34:28 2009 +0200
@@ -56,11 +56,12 @@
 {
 	int	temp;
 	size_t	len = sizeof(temp);
-	char	mibname[31];
+	char *mibname;
 
 	/* Get the CPU Temperature via dev.cpu.<number>.temperature */
-	sprintf(mibname, "dev.cpu.%i.temperature", cpu_number);
+	asprintf(&mibname, "dev.cpu.%i.temperature", cpu_number);
 	sysctlbyname(mibname, &temp, &len, NULL, 0);
+	free(mibname);
 
 	return (temp);
 }
@@ -133,9 +134,9 @@
 print_cpu_temp(int cpu_number, unsigned int flags)
 {
 	/* Test if the Sysctl OID realy exist */
-	char mibname[31];
+	char *mibname;
 
-	(void)sprintf(mibname, "dev.cpu.%i.temperature", cpu_number);
+	(void)asprintf(&mibname, "dev.cpu.%i.temperature", cpu_number);
 	if (sysctlbyname(mibname, NULL, NULL, NULL, 0) < 0) {
 		/* Errr, something wrong... */
 		(void)printf("    CPU%i:        Cannot get temperature\n",
@@ -146,6 +147,8 @@
 		    convert_temp( get_cpu_temp(cpu_number), flags),
 		    get_temp_ext(flags));
 	}
+
+	free(mibname);
 }
 
 
@@ -208,14 +211,15 @@
 	 * print temp for each
 	 */
 	int *acpi_number = 0;
+	char *mibname;
 
 	while (&acpi_number != NULL) {
 		int	temp, error, sensor_found = 0;
 		size_t	len = sizeof(temp);
-		char	mibname[60];
 
-		sprintf(mibname, "hw.acpi.thermal.tz%i.temperature", (int)acpi_number);
+		asprintf(&mibname, "hw.acpi.thermal.tz%i.temperature", (int)acpi_number);
 		error = sysctlbyname(mibname, &temp, &len, NULL, 0);
+		free(mibname);
 		if (error < 0) {
 			/* Error, possibility of non-existant node, set acpi_number to NULL */
 			if (acpi_number == 0)
